config/routes.rb
Authorization::Engine.routes.draw do
  resources :roles, except: [:show] do
    get 'assign_users'
    get 'assign_permissions'
  end
end

app/models/authorization/action.rb
module Authorization
  class Action < ActiveRecord::Base
    belongs_to :activity

    def to_s
      desc or name.capitalize
    end
  end
end

app/models/authorization/activity.rb
module Authorization
  class Activity < ActiveRecord::Base
    has_many :actions
    has_many :permissions
    has_many :roles, through: :permissions

    def to_s
      desc or scenario.capitalize
    end

    def actions_list
      actions = []
      real_actions = {}
      
      self.actions.each do |action|
        real_actions[action.to_s] = action.id
      end

      temp = []
      temp << real_actions["Index"] if real_actions.has_key? "Index"
      temp << real_actions["Show"] if real_actions.has_key? "Show"
      actions << {name:"Read Permission", id: temp.join(", ")} unless temp.empty?
      
      temp = []
      temp << real_actions["New"] if real_actions.has_key? "New"
      temp << real_actions["Create"] if real_actions.has_key? "Create"
      actions << {name:"Write Permission", id: temp.join(", ")} unless temp.empty?

      temp = []
      temp << real_actions["Edit"] if real_actions.has_key? "Edit"
      temp << real_actions["Update"] if real_actions.has_key? "Update"
      actions << {name:"Update Permission", id: temp.join(", ")} unless temp.empty?

      actions << {name:"Remove Permission", id: real_actions["Destroy"]} if real_actions.has_key? "Destroy"
      real_actions.tap do |hs| 
        hs.delete("Index")
        hs.delete("Show")

        hs.delete("New")
        hs.delete("Create")

        hs.delete("Edit")
        hs.delete("Update")

        hs.delete("Destroy")
      end
      real_actions.keys.each do |key|
        actions << {name: key.to_s.capitalize + " Permission", id: real_actions[key]}
      end
      actions
    end
  end
end

app/models/authorization/duty.rb
module Authorization
  class Duty < ActiveRecord::Base
    belongs_to :user
    belongs_to :role
  end
end

app/models/authorization/permission.rb
module Authorization
  class Permission < ActiveRecord::Base
    belongs_to :role
    belongs_to :action
  end
end

app/models/authorization/role.rb
module Authorization
  class Role < ActiveRecord::Base
    has_many :duties
    has_many :permissions
    has_many :users, class_name: "User", through: :duties
    has_many :actions, through: :permissions

    def to_s
      name.capitalize
    end
  end
end

app/controllers/authorization/application_controller.rb
class Authorization::ApplicationController < ApplicationController
  layout 'layouts/application'
end

app/controllers/authorization/roles_controller.rb
require_dependency "authorization/application_controller"

module Authorization
  class RolesController < ApplicationController
    before_action :set_role, only: [:edit, :update, :destroy]

    # GET /roles
    def index
      @roles = policy_scope(Role.all)
      authorize @roles
    end

    # GET /roles/new
    def new
      @role = Role.new
      authorize(@role)
    end

    # GET /roles/1/edit
    def edit
    end

    # POST /roles
    def create
      @role = Role.new(role_params)
      authorize(@role)

      if @role.save
        redirect_to roles_url, notice: 'Role was successfully created.'
      else
        render :new
      end
    end

    # PATCH/PUT /roles/1
    def update
      params = role_params
      if role_params[:action_ids].present?
        action_ids = []
        role_params[:action_ids].each do |ids|
          ids.split(", ").each do |id|
            action_ids << id
          end
        end
        params[:action_ids] = action_ids
      end

      if @role.update(params)
        redirect_to roles_url, notice: 'Role was successfully updated.'
      else
        render :edit
      end
    end

    # DELETE /roles/1
    def destroy
      if @role.is_basic
        redirect_to roles_url, :flash => { :error => "The role cannot be removed." }
      else
        @role.destroy
        redirect_to roles_url, notice: 'Role was successfully destroyed.'
      end
    end

    def assign_users
      @role = Role.find(params[:role_id])
      authorize(@role)
    end

    def assign_permissions
      @role = Role.find(params[:role_id])
      authorize(@role)
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_role
        @role = Role.find(params[:id])
        authorize(@role)
      end

      # Only allow a trusted parameter "white list" through.
      def role_params
        params.require(:role).permit(:name, :is_basic, user_ids: [], action_ids:[])
      end
  end
end

app/helpers/authorization/application_helper.rb
module Authorization
  module ApplicationHelper
    def method_missing(method, *args, &block)
      if (method.to_s.end_with?('_path') || method.to_s.end_with?('_url')) && main_app.respond_to?(method)
        main_app.send(method, *args)
      else
        super
      end
    end
  end
end

app/helpers/authorization/roles_helper.rb
module Authorization
  module RolesHelper
  end
end

app/views/authorization/roles/_form.html.haml
= form_for(@role, html: {class: "ui fluid form"}) do |f|
  - if @role.errors.any?
    #error_explanation
      %h2= "#{pluralize(@role.errors.count, "error")} prohibited this role from being saved:"
      %ul
        - @role.errors.full_messages.each do |message|
          %li= message
  .field
    = f.label :name
    = f.text_field :name
  .field
    = f.label :is_basic
    = f.check_box :is_basic
  .actions
    = f.submit

app/views/authorization/roles/assign_permissions.haml
= form_for @role, html:{class: "ui fluid form"} do |f|
  - if @role.errors.any?
    #error_explanation
      %h2= "#{pluralize(@role.errors.count, "error")} prohibited this permission from being saved:"
      %ul
        - @role.errors.full_messages.each do |message|
          %li= message

  .ui.padded.grid.stackable
    - activities = Authorization::Activity.all
    - activities.each do |activity|
      .four.wide.column
        .ui.inverted.red.segment
          %h4.ui.header= "#{activity}"
          .ui.list
            - activity.actions_list.each do |action|
              .ui.checkbox.item
                = check_box_tag "role[action_ids][]", action[:id], @role.action_ids.include?(action[:id].to_i)
                %label= "#{action[:name]}"
  .actions
    %br/
    = f.submit class:"ui submit button"

app/views/authorization/roles/assign_users.html.haml
= form_for @role, html: {class: "ui compact fluid form"} do |f|
  - if @role.errors.any?
    %div.ui.negative.message
      %h2= "#{pluralize(@role.errors.count, "error")} prohibited this form from being saved:"
      %ul
        - @role.errors.full_messages.each do |message|
          %li= message
  .field
    = f.collection_check_boxes :user_ids, User.all, :id, :first_name
  .actions
    = f.submit class: "ui submit button"

app/views/authorization/roles/edit.html.erb
<h1>Editing Role</h1>

<%= render 'form' %>

<%= link_to 'Show', @role %> |
<%= link_to 'Back', roles_path %>

app/views/authorization/roles/index.html.haml
%h1 Listing Roles
%table.ui.table
  %thead
    %tr
      %th Name
      %th{:colspan => "4"}
  %tbody
    - @roles.each do |role|
      %tr
        %td= role.name
        %td= link_to 'Users', role_assign_users_path(role)
        %td= link_to 'Permissions', role_assign_permissions_path(role)
        %td= link_to 'Edit', edit_role_path(role)
        %td= link_to 'Remove', role, method: :delete, data: { confirm: 'Are you sure?' }
%br/
= link_to 'New Role', new_role_path

app/views/authorization/roles/new.html.erb
<h1>New Role</h1>

<%= render 'form' %>

<%= link_to 'Back', roles_path %>

app/views/layouts/authorization/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Authorization</title>
  <%= stylesheet_link_tag    "authorization/application", media: "all" %>
  <%= javascript_include_tag "authorization/application" %>
  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

</body>
</html>